/***************************************************************************
                          directory.h  -  description
                             -------------------
    begin                : Sat Jul 1 2000
    copyright            : (C) 2000 by Calvin Harrigan
    email                : charrig@viaccess.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef __DIRECTORY_H__
#define __DIRECTORY_H__

// The directory class takes a directory and indexes all of the songs held
// in it and makes them available for use in the songlist class.

#include <stdio.h>
struct Song
{
	char * path;
	char * name;
};

class Directory
{
	private:
		char name[100];        // Name of the directory
		bool fFlag;            // fail flag
		int songListSize;      // number of songs in the directory
		Song ** list;          // pointer array of 'Song' objects
		bool available;        // availability flag.
	public:
		Directory(){};
		Directory(char* directory);  // Constructor
		~Directory();
		int GetSongCount()const{return songListSize;}; // returns the count of songs in the directory
		void GetDirectoryName(char *buffer, int length)const;  // returns the name of the directory(genre)
		bool GetAvailable()const{return available;};           // returns the availability status
		void SetAvailable(bool avail){available = avail;};     // sets the availability status
		Song ** GetSongs()const;                               // returns the pointer to the array of songs
		bool Fail()const{return fFlag;};                       // returns the fail flag
};

#endif // __DIRECTORY_H__
//============END OF FILE=====================		