/***************************************************************************
                          queue.cpp  -  description
                             -------------------
    begin                : Tue Jun 13 2000
    copyright            : (C) 2000 by Calvin Harrigan
    email                : charrig@viaccess.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "queue.h"
#include <stdlib.h>

// Constructor
Queue::Queue(int qs) : qsize(qs)
{
	front = rear = NULL;
	items = 0;
}

// Destructor
Queue::~Queue()
{
	Node * temp;
	while (front != NULL)	// while queue is not yet empty
	{
		temp = front;		// save address of front item
		front = front->next;// reset pointer to next item
		delete temp;		// delete former front
	}
}

bool Queue::isempty() const
{
	return items == 0 ? true : false;
}

bool Queue::isfull() const
{
	return items == qsize ? true : false;
}

// returns the count of items in the queue
int Queue::queuecount() const
{
	return items;
}

// Add item to queue
bool Queue::enqueue(const int & item)
{
	if (isfull())
		return false;
	Node * add = new Node;	// create node
	if (add == NULL)
		return false;		// quit if none available
	add->item = item;		// set node pointers
	add->next = NULL;
	items++;
	if (front == NULL)		// if queue is empty,
		front = add;		// place item at front
	else
		rear->next = add;	// else place at rear
	rear = add; 			// have rear point to new node
	return true;
}

// Place front item into item variable and remove from queue
bool Queue::dequeue(int & item)
{
	if (front == NULL)
		return false;
	item = front->item;		// set item to first item in queue
	items--;
	Node * temp = front;		// save location of first item
	front = front->next;		// reset front to next item
	delete temp;			// delete former first item
	if (items == 0)
		rear = NULL;
	return true;
}

