/***************************************************************************
                          queue.h  -  description
                             -------------------
    begin                : Tue Jun 13 2000
    copyright            : (C) 2000 by Calvin Harrigan
    email                : charrig@viaccess.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _QUEUE_H_
#define _QUEUE_H_

class Queue
{
// class scope definitions
	// Node is a nested structure definition local to this class
	struct Node { int item; struct Node * next;};
	enum {Q_SIZE = 50};
private:
	Node * front;		// pointer to front of Queue
	Node * rear;		// pointer to rear of Queue
	int items;		// current number of items in Queue
	const int qsize;	// maximum number of items in Queue
	Queue(const Queue & q) : qsize(0) { }	// preemptive definition
	Queue & operator=(const Queue & q) { return *this;}
public:
	Queue(int qs = Q_SIZE);	// create queue with a qs limit
	~Queue();
	bool isempty() const;
	bool isfull() const;
	int queuecount() const;
	bool enqueue(const int &item);	// add item to end
	bool dequeue(int &item);		// remove item from front
};
#endif

